# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class AccountServiceBudget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'amount': 'int',
        'end_date': 'str',
        'limit_charge_type': 'AccountServiceLimitChargeType',
        'start_date': 'str'
    }

    attribute_map = {
        'amount': 'amount',
        'end_date': 'endDate',
        'limit_charge_type': 'limitChargeType',
        'start_date': 'startDate'
    }

    def __init__(self, amount=None, end_date=None, limit_charge_type=None, start_date=None, local_vars_configuration=None):  # noqa: E501
        """AccountServiceBudget - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._amount = None
        self._end_date = None
        self._limit_charge_type = None
        self._start_date = None
        self.discriminator = None

        self.amount = amount
        self.end_date = end_date
        self.limit_charge_type = limit_charge_type
        self.start_date = start_date

    @property
    def amount(self):
        """Gets the amount of this AccountServiceBudget.  # noqa: E501

        <div lang=\"ja\">アカウントの広告予算金額です。<br> SET時、このフィールドは無視されます。</div> <div lang=\"en\">Amount of budget.<br> This field will be ignored in SET operation.</div>   # noqa: E501

        :return: The amount of this AccountServiceBudget.  # noqa: E501
        :rtype: int
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this AccountServiceBudget.

        <div lang=\"ja\">アカウントの広告予算金額です。<br> SET時、このフィールドは無視されます。</div> <div lang=\"en\">Amount of budget.<br> This field will be ignored in SET operation.</div>   # noqa: E501

        :param amount: The amount of this AccountServiceBudget.  # noqa: E501
        :type: int
        """

        self._amount = amount

    @property
    def end_date(self):
        """Gets the end_date of this AccountServiceBudget.  # noqa: E501

        <div lang=\"ja\">掲載終了日です。<br> SET時、このフィールドは無視されます。<br>「yyyyMMdd」形式で表示されます。</div> <div lang=\"en\">End date of ad serving.<br>This field will be ignored in SET operation.<br> It is displayed in &#39;yyyyMMdd&#39; format.</div>   # noqa: E501

        :return: The end_date of this AccountServiceBudget.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this AccountServiceBudget.

        <div lang=\"ja\">掲載終了日です。<br> SET時、このフィールドは無視されます。<br>「yyyyMMdd」形式で表示されます。</div> <div lang=\"en\">End date of ad serving.<br>This field will be ignored in SET operation.<br> It is displayed in &#39;yyyyMMdd&#39; format.</div>   # noqa: E501

        :param end_date: The end_date of this AccountServiceBudget.  # noqa: E501
        :type: str
        """

        self._end_date = end_date

    @property
    def limit_charge_type(self):
        """Gets the limit_charge_type of this AccountServiceBudget.  # noqa: E501


        :return: The limit_charge_type of this AccountServiceBudget.  # noqa: E501
        :rtype: AccountServiceLimitChargeType
        """
        return self._limit_charge_type

    @limit_charge_type.setter
    def limit_charge_type(self, limit_charge_type):
        """Sets the limit_charge_type of this AccountServiceBudget.


        :param limit_charge_type: The limit_charge_type of this AccountServiceBudget.  # noqa: E501
        :type: AccountServiceLimitChargeType
        """

        self._limit_charge_type = limit_charge_type

    @property
    def start_date(self):
        """Gets the start_date of this AccountServiceBudget.  # noqa: E501

        <div lang=\"ja\">掲載開始日です。<br> 「yyyyMMdd」形式で表示されます。<br> SET時、このフィールドは無視されます。</div> <div lang=\"en\">Start date of ad serving.<br> This field will be ignored in SET operation.<br> It is displayed in &#39;yyyyMMdd&#39; format.</div>   # noqa: E501

        :return: The start_date of this AccountServiceBudget.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this AccountServiceBudget.

        <div lang=\"ja\">掲載開始日です。<br> 「yyyyMMdd」形式で表示されます。<br> SET時、このフィールドは無視されます。</div> <div lang=\"en\">Start date of ad serving.<br> This field will be ignored in SET operation.<br> It is displayed in &#39;yyyyMMdd&#39; format.</div>   # noqa: E501

        :param start_date: The start_date of this AccountServiceBudget.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountServiceBudget):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountServiceBudget):
            return True

        return self.to_dict() != other.to_dict()
