# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class AdGroupAdServiceAppAd(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'app_id': 'str',
        'app_store': 'AdGroupAdServiceAppStore',
        'description2': 'str'
    }

    attribute_map = {
        'app_id': 'appId',
        'app_store': 'appStore',
        'description2': 'description2'
    }

    def __init__(self, app_id=None, app_store=None, description2=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupAdServiceAppAd - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._app_id = None
        self._app_store = None
        self._description2 = None
        self.discriminator = None

        self.app_id = app_id
        self.app_store = app_store
        self.description2 = description2

    @property
    def app_id(self):
        """Gets the app_id of this AdGroupAdServiceAppAd.  # noqa: E501

        <div lang=\"ja\">アプリIDです。<br> ※アプリキャンペーンの 場合、自動で設定され ます。</div> <div lang=\"en\">App ID.<br> *Automatically set for Mobile app campaign.</div>   # noqa: E501

        :return: The app_id of this AdGroupAdServiceAppAd.  # noqa: E501
        :rtype: str
        """
        return self._app_id

    @app_id.setter
    def app_id(self, app_id):
        """Sets the app_id of this AdGroupAdServiceAppAd.

        <div lang=\"ja\">アプリIDです。<br> ※アプリキャンペーンの 場合、自動で設定され ます。</div> <div lang=\"en\">App ID.<br> *Automatically set for Mobile app campaign.</div>   # noqa: E501

        :param app_id: The app_id of this AdGroupAdServiceAppAd.  # noqa: E501
        :type: str
        """

        self._app_id = app_id

    @property
    def app_store(self):
        """Gets the app_store of this AdGroupAdServiceAppAd.  # noqa: E501


        :return: The app_store of this AdGroupAdServiceAppAd.  # noqa: E501
        :rtype: AdGroupAdServiceAppStore
        """
        return self._app_store

    @app_store.setter
    def app_store(self, app_store):
        """Sets the app_store of this AdGroupAdServiceAppAd.


        :param app_store: The app_store of this AdGroupAdServiceAppAd.  # noqa: E501
        :type: AdGroupAdServiceAppStore
        """

        self._app_store = app_store

    @property
    def description2(self):
        """Gets the description2 of this AdGroupAdServiceAppAd.  # noqa: E501

        <div lang=\"ja\">説明文（2行目）2です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Description2 (line2) of the ad.<br> This field is required in ADD operation.</div>   # noqa: E501

        :return: The description2 of this AdGroupAdServiceAppAd.  # noqa: E501
        :rtype: str
        """
        return self._description2

    @description2.setter
    def description2(self, description2):
        """Sets the description2 of this AdGroupAdServiceAppAd.

        <div lang=\"ja\">説明文（2行目）2です。<br> ADD時、このフィールドは必須となります。</div> <div lang=\"en\">Description2 (line2) of the ad.<br> This field is required in ADD operation.</div>   # noqa: E501

        :param description2: The description2 of this AdGroupAdServiceAppAd.  # noqa: E501
        :type: str
        """

        self._description2 = description2

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupAdServiceAppAd):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupAdServiceAppAd):
            return True

        return self.to_dict() != other.to_dict()
