# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class AdGroupWebpage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'ad_group_id': 'int',
        'ad_group_track_id': 'int',
        'bid': 'AdGroupWebpageServiceBid',
        'campaign_id': 'int',
        'campaign_track_id': 'int',
        'excluded_type': 'AdGroupWebpageServiceExcludedType',
        'user_status': 'AdGroupWebpageServiceUserStatus',
        'webpage': 'AdGroupWebpageServiceWebpage'
    }

    attribute_map = {
        'account_id': 'accountId',
        'ad_group_id': 'adGroupId',
        'ad_group_track_id': 'adGroupTrackId',
        'bid': 'bid',
        'campaign_id': 'campaignId',
        'campaign_track_id': 'campaignTrackId',
        'excluded_type': 'excludedType',
        'user_status': 'userStatus',
        'webpage': 'webpage'
    }

    def __init__(self, account_id=None, ad_group_id=None, ad_group_track_id=None, bid=None, campaign_id=None, campaign_track_id=None, excluded_type=None, user_status=None, webpage=None, local_vars_configuration=None):  # noqa: E501
        """AdGroupWebpage - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._ad_group_id = None
        self._ad_group_track_id = None
        self._bid = None
        self._campaign_id = None
        self._campaign_track_id = None
        self._excluded_type = None
        self._user_status = None
        self._webpage = None
        self.discriminator = None

        self.account_id = account_id
        self.ad_group_id = ad_group_id
        self.ad_group_track_id = ad_group_track_id
        self.bid = bid
        self.campaign_id = campaign_id
        self.campaign_track_id = campaign_track_id
        self.excluded_type = excluded_type
        self.user_status = user_status
        self.webpage = webpage

    @property
    def account_id(self):
        """Gets the account_id of this AdGroupWebpage.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The account_id of this AdGroupWebpage.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this AdGroupWebpage.

        <div lang=\"ja\">アカウントIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Account ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param account_id: The account_id of this AdGroupWebpage.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this AdGroupWebpage.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Ad Group ID.<br>This field is required in any cases.</div>   # noqa: E501

        :return: The ad_group_id of this AdGroupWebpage.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this AdGroupWebpage.

        <div lang=\"ja\">広告グループIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Ad Group ID.<br>This field is required in any cases.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this AdGroupWebpage.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def ad_group_track_id(self):
        """Gets the ad_group_track_id of this AdGroupWebpage.  # noqa: E501

        <div lang=\"ja\">広告グループトラッキングIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Ad Group Tracking ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The ad_group_track_id of this AdGroupWebpage.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_track_id

    @ad_group_track_id.setter
    def ad_group_track_id(self, ad_group_track_id):
        """Sets the ad_group_track_id of this AdGroupWebpage.

        <div lang=\"ja\">広告グループトラッキングIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Ad Group Tracking ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param ad_group_track_id: The ad_group_track_id of this AdGroupWebpage.  # noqa: E501
        :type: int
        """

        self._ad_group_track_id = ad_group_track_id

    @property
    def bid(self):
        """Gets the bid of this AdGroupWebpage.  # noqa: E501


        :return: The bid of this AdGroupWebpage.  # noqa: E501
        :rtype: AdGroupWebpageServiceBid
        """
        return self._bid

    @bid.setter
    def bid(self, bid):
        """Sets the bid of this AdGroupWebpage.


        :param bid: The bid of this AdGroupWebpage.  # noqa: E501
        :type: AdGroupWebpageServiceBid
        """

        self._bid = bid

    @property
    def campaign_id(self):
        """Gets the campaign_id of this AdGroupWebpage.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br>This field is required in any cases.</div>   # noqa: E501

        :return: The campaign_id of this AdGroupWebpage.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this AdGroupWebpage.

        <div lang=\"ja\">キャンペーンIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br>This field is required in any cases.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this AdGroupWebpage.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_track_id(self):
        """Gets the campaign_track_id of this AdGroupWebpage.  # noqa: E501

        <div lang=\"ja\">キャンペーントラッキングIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign Tracking ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The campaign_track_id of this AdGroupWebpage.  # noqa: E501
        :rtype: int
        """
        return self._campaign_track_id

    @campaign_track_id.setter
    def campaign_track_id(self, campaign_track_id):
        """Sets the campaign_track_id of this AdGroupWebpage.

        <div lang=\"ja\">キャンペーントラッキングIDです。<br>このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Campaign Tracking ID.<br>Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param campaign_track_id: The campaign_track_id of this AdGroupWebpage.  # noqa: E501
        :type: int
        """

        self._campaign_track_id = campaign_track_id

    @property
    def excluded_type(self):
        """Gets the excluded_type of this AdGroupWebpage.  # noqa: E501


        :return: The excluded_type of this AdGroupWebpage.  # noqa: E501
        :rtype: AdGroupWebpageServiceExcludedType
        """
        return self._excluded_type

    @excluded_type.setter
    def excluded_type(self, excluded_type):
        """Sets the excluded_type of this AdGroupWebpage.


        :param excluded_type: The excluded_type of this AdGroupWebpage.  # noqa: E501
        :type: AdGroupWebpageServiceExcludedType
        """

        self._excluded_type = excluded_type

    @property
    def user_status(self):
        """Gets the user_status of this AdGroupWebpage.  # noqa: E501


        :return: The user_status of this AdGroupWebpage.  # noqa: E501
        :rtype: AdGroupWebpageServiceUserStatus
        """
        return self._user_status

    @user_status.setter
    def user_status(self, user_status):
        """Sets the user_status of this AdGroupWebpage.


        :param user_status: The user_status of this AdGroupWebpage.  # noqa: E501
        :type: AdGroupWebpageServiceUserStatus
        """

        self._user_status = user_status

    @property
    def webpage(self):
        """Gets the webpage of this AdGroupWebpage.  # noqa: E501


        :return: The webpage of this AdGroupWebpage.  # noqa: E501
        :rtype: AdGroupWebpageServiceWebpage
        """
        return self._webpage

    @webpage.setter
    def webpage(self, webpage):
        """Sets the webpage of this AdGroupWebpage.


        :param webpage: The webpage of this AdGroupWebpage.  # noqa: E501
        :type: AdGroupWebpageServiceWebpage
        """

        self._webpage = webpage

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AdGroupWebpage):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AdGroupWebpage):
            return True

        return self.to_dict() != other.to_dict()
