# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class AuditLogServiceEventSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'entity_type': 'str',
        'event_types': 'list[AuditLogServiceEventTypes]'
    }

    attribute_map = {
        'entity_type': 'entityType',
        'event_types': 'eventTypes'
    }

    def __init__(self, entity_type=None, event_types=None, local_vars_configuration=None):  # noqa: E501
        """AuditLogServiceEventSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._entity_type = None
        self._event_types = None
        self.discriminator = None

        self.entity_type = entity_type
        self.event_types = event_types

    @property
    def entity_type(self):
        """Gets the entity_type of this AuditLogServiceEventSelector.  # noqa: E501

        <div lang=\"ja\">AuditLogServiceEntityTypeオブジェクトは、操作履歴に出力するエンティティの種類を表します。</div> <div lang=\"en\">AuditLogServiceEntityType object describes the type of entities to be output on the data of operation history.</div> <hr> <p>* <code>CAMPAIGN</code> - <span lang=\"ja\">キャンペーンです。</span><span lang=\"en\">Campaign.</span></p> <p>* <code>NEGATIVE_CAMPAIGN_CRITERION</code> - <span lang=\"ja\">対象外キーワードです（キャンペーン）。</span><span lang=\"en\">Negative keywords (for campaign)</span></p> <p>* <code>CAMPAIGN_CRITERION</code> - <span lang=\"ja\">キャンペーンのターゲティング設定です。</span><span lang=\"en\">Targeting setting on campaign.</span></p> <p>* <code>AD_GROUP</code> - <span lang=\"ja\">広告グループです。</span><span lang=\"en\">Ad group.</span></p> <p>* <code>AD_GROUP_BID_MULTIPLIER</code> - <span lang=\"ja\">広告グループ入札価格調整率です。</span><span lang=\"en\">Bid adjustment for ad group.</span></p> <p>* <code>BIDDABLE_AD_GROUP_CRITERION</code> - <span lang=\"ja\">入札キーワードです。</span><span lang=\"en\">Bidding keyword.</span></p> <p>* <code>NEGATIVE_AD_GROUP_CRITERION</code> - <span lang=\"ja\">対象外キーワードです（広告グループ）。</span><span lang=\"en\">Negative keywords (for ad group)</span></p> <p>* <code>AD</code> - <span lang=\"ja\">広告です。</span><span lang=\"en\">Ad.</span></p> <p>* <code>FEED</code> - <span lang=\"ja\">Feedフォルダーです。</span><span lang=\"en\">Feed folder.</span></p> <p>* <code>FEED_ITEM</code> - <span lang=\"ja\">広告表示オプションです。</span><span lang=\"en\">Ad display options.</span></p> <p>* <code>CAMPAIGN_FEED</code> - <span lang=\"ja\">広告表示オプションです（キャンペーン）。</span><span lang=\"en\">Ad display options for campaign.</span></p> <p>* <code>AD_GROUP_FEED</code> - <span lang=\"ja\">広告表示オプションです（広告グループ）。</span><span lang=\"en\">Ad display options for ad group.</span></p> <p>* <code>SS_IO</code> - <span lang=\"ja\">アカウントです。</span><span lang=\"en\">Account.</span></p> <p>* <code>SS_CONVERSION</code> - <span lang=\"ja\">コンバージョントラッカー（コンバージョン測定）です。</span><span lang=\"en\">Conversion tracker for conversion tracking.</span></p> <p>* <code>BIDDING_STRATEGY</code> - <span lang=\"ja\">自動入札設定です。</span><span lang=\"en\">Auto bidding setting.</span></p> <p>* <code>NEGATIVE_CAMPAIGN_USER_LIST</code> - <span lang=\"ja\">対象外ターゲットリストです（キャンペーン）。</span><span lang=\"en\">Exclude target list for campaign.</span></p> <p>* <code>NEGATIVE_AD_GROUP_USER_LIST</code> - <span lang=\"ja\">対象外ターゲットリストです（広告グループ）。</span><span lang=\"en\">Exclude target list for ad group.</span></p> <p>* <code>AD_GROUP_USER_LIST</code> - <span lang=\"ja\">ターゲットリストです（広告グループ）。</span><span lang=\"en\">Target list for ad group.</span></p> <p>* <code>TARGET_LIST</code> - <span lang=\"ja\">サイトリターゲテイングのターゲットリストです。</span><span lang=\"en\">Target list of Site Retargeting.</span></p> <p>* <code>SHARED_SET</code> - <span lang=\"ja\">共有リストです。</span><span lang=\"en\">Shared list.</span></p> <p>* <code>SHARED_CRITERION</code> - <span lang=\"ja\">共有キーワードです。</span><span lang=\"en\">Shared keywords.</span></p> <p>* <code>CAMPAIGN_SHARED_SET</code> - <span lang=\"ja\">キャンペーン共有リストです。</span><span lang=\"en\">Shared list for campaign.</span></p> <p>* <code>AD_CUSTOMIZER</code> - <span lang=\"ja\">アドカスタマイザーです。</span><span lang=\"en\">Ad customizer.</span></p> <p>* <code>EXCLUDE_AD_CUSTOMIZER</code> - <span lang=\"ja\">アドカスタマイザーを除くすべての履歴です。</span><span lang=\"en\">All operation history excepting ad customizer.</span></p> <p>* <code>ALL</code> - <span lang=\"ja\">すべての履歴です。</span><span lang=\"en\">All operation history.</span></p> <p>* <code>UNKNOWN</code> - <span lang=\"ja\">未知の値です。</span><span lang=\"en\">Unknown Value</span></p>   # noqa: E501

        :return: The entity_type of this AuditLogServiceEventSelector.  # noqa: E501
        :rtype: str
        """
        return self._entity_type

    @entity_type.setter
    def entity_type(self, entity_type):
        """Sets the entity_type of this AuditLogServiceEventSelector.

        <div lang=\"ja\">AuditLogServiceEntityTypeオブジェクトは、操作履歴に出力するエンティティの種類を表します。</div> <div lang=\"en\">AuditLogServiceEntityType object describes the type of entities to be output on the data of operation history.</div> <hr> <p>* <code>CAMPAIGN</code> - <span lang=\"ja\">キャンペーンです。</span><span lang=\"en\">Campaign.</span></p> <p>* <code>NEGATIVE_CAMPAIGN_CRITERION</code> - <span lang=\"ja\">対象外キーワードです（キャンペーン）。</span><span lang=\"en\">Negative keywords (for campaign)</span></p> <p>* <code>CAMPAIGN_CRITERION</code> - <span lang=\"ja\">キャンペーンのターゲティング設定です。</span><span lang=\"en\">Targeting setting on campaign.</span></p> <p>* <code>AD_GROUP</code> - <span lang=\"ja\">広告グループです。</span><span lang=\"en\">Ad group.</span></p> <p>* <code>AD_GROUP_BID_MULTIPLIER</code> - <span lang=\"ja\">広告グループ入札価格調整率です。</span><span lang=\"en\">Bid adjustment for ad group.</span></p> <p>* <code>BIDDABLE_AD_GROUP_CRITERION</code> - <span lang=\"ja\">入札キーワードです。</span><span lang=\"en\">Bidding keyword.</span></p> <p>* <code>NEGATIVE_AD_GROUP_CRITERION</code> - <span lang=\"ja\">対象外キーワードです（広告グループ）。</span><span lang=\"en\">Negative keywords (for ad group)</span></p> <p>* <code>AD</code> - <span lang=\"ja\">広告です。</span><span lang=\"en\">Ad.</span></p> <p>* <code>FEED</code> - <span lang=\"ja\">Feedフォルダーです。</span><span lang=\"en\">Feed folder.</span></p> <p>* <code>FEED_ITEM</code> - <span lang=\"ja\">広告表示オプションです。</span><span lang=\"en\">Ad display options.</span></p> <p>* <code>CAMPAIGN_FEED</code> - <span lang=\"ja\">広告表示オプションです（キャンペーン）。</span><span lang=\"en\">Ad display options for campaign.</span></p> <p>* <code>AD_GROUP_FEED</code> - <span lang=\"ja\">広告表示オプションです（広告グループ）。</span><span lang=\"en\">Ad display options for ad group.</span></p> <p>* <code>SS_IO</code> - <span lang=\"ja\">アカウントです。</span><span lang=\"en\">Account.</span></p> <p>* <code>SS_CONVERSION</code> - <span lang=\"ja\">コンバージョントラッカー（コンバージョン測定）です。</span><span lang=\"en\">Conversion tracker for conversion tracking.</span></p> <p>* <code>BIDDING_STRATEGY</code> - <span lang=\"ja\">自動入札設定です。</span><span lang=\"en\">Auto bidding setting.</span></p> <p>* <code>NEGATIVE_CAMPAIGN_USER_LIST</code> - <span lang=\"ja\">対象外ターゲットリストです（キャンペーン）。</span><span lang=\"en\">Exclude target list for campaign.</span></p> <p>* <code>NEGATIVE_AD_GROUP_USER_LIST</code> - <span lang=\"ja\">対象外ターゲットリストです（広告グループ）。</span><span lang=\"en\">Exclude target list for ad group.</span></p> <p>* <code>AD_GROUP_USER_LIST</code> - <span lang=\"ja\">ターゲットリストです（広告グループ）。</span><span lang=\"en\">Target list for ad group.</span></p> <p>* <code>TARGET_LIST</code> - <span lang=\"ja\">サイトリターゲテイングのターゲットリストです。</span><span lang=\"en\">Target list of Site Retargeting.</span></p> <p>* <code>SHARED_SET</code> - <span lang=\"ja\">共有リストです。</span><span lang=\"en\">Shared list.</span></p> <p>* <code>SHARED_CRITERION</code> - <span lang=\"ja\">共有キーワードです。</span><span lang=\"en\">Shared keywords.</span></p> <p>* <code>CAMPAIGN_SHARED_SET</code> - <span lang=\"ja\">キャンペーン共有リストです。</span><span lang=\"en\">Shared list for campaign.</span></p> <p>* <code>AD_CUSTOMIZER</code> - <span lang=\"ja\">アドカスタマイザーです。</span><span lang=\"en\">Ad customizer.</span></p> <p>* <code>EXCLUDE_AD_CUSTOMIZER</code> - <span lang=\"ja\">アドカスタマイザーを除くすべての履歴です。</span><span lang=\"en\">All operation history excepting ad customizer.</span></p> <p>* <code>ALL</code> - <span lang=\"ja\">すべての履歴です。</span><span lang=\"en\">All operation history.</span></p> <p>* <code>UNKNOWN</code> - <span lang=\"ja\">未知の値です。</span><span lang=\"en\">Unknown Value</span></p>   # noqa: E501

        :param entity_type: The entity_type of this AuditLogServiceEventSelector.  # noqa: E501
        :type: str
        """

        self._entity_type = entity_type

    @property
    def event_types(self):
        """Gets the event_types of this AuditLogServiceEventSelector.  # noqa: E501


        :return: The event_types of this AuditLogServiceEventSelector.  # noqa: E501
        :rtype: list[AuditLogServiceEventTypes]
        """
        return self._event_types

    @event_types.setter
    def event_types(self, event_types):
        """Sets the event_types of this AuditLogServiceEventSelector.


        :param event_types: The event_types of this AuditLogServiceEventSelector.  # noqa: E501
        :type: list[AuditLogServiceEventTypes]
        """

        self._event_types = event_types

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AuditLogServiceEventSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AuditLogServiceEventSelector):
            return True

        return self.to_dict() != other.to_dict()
