# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class BidLandscape(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'campaign_id': 'int',
        'ad_group_id': 'int',
        'start_date': 'str',
        'end_date': 'str',
        'landscape_points': 'list[BidLandscapeServicePoints]',
        'bid_landscape_type': 'str',
        'ad_group_bid_landscape': 'BidLandscapeServiceAdGroupBidLandscape',
        'criterion_bid_landscape': 'BidLandscapeServiceCriterionBidLandscape'
    }

    attribute_map = {
        'campaign_id': 'campaignId',
        'ad_group_id': 'adGroupId',
        'start_date': 'startDate',
        'end_date': 'endDate',
        'landscape_points': 'landscapePoints',
        'bid_landscape_type': 'bidLandscapeType',
        'ad_group_bid_landscape': 'adGroupBidLandscape',
        'criterion_bid_landscape': 'criterionBidLandscape'
    }

    def __init__(self, campaign_id=None, ad_group_id=None, start_date=None, end_date=None, landscape_points=None, bid_landscape_type=None, ad_group_bid_landscape=None, criterion_bid_landscape=None, local_vars_configuration=None):  # noqa: E501
        """BidLandscape - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._campaign_id = None
        self._ad_group_id = None
        self._start_date = None
        self._end_date = None
        self._landscape_points = None
        self._bid_landscape_type = None
        self._ad_group_bid_landscape = None
        self._criterion_bid_landscape = None
        self.discriminator = None

        self.campaign_id = campaign_id
        self.ad_group_id = ad_group_id
        self.start_date = start_date
        self.end_date = end_date
        self.landscape_points = landscape_points
        self.bid_landscape_type = bid_landscape_type
        self.ad_group_bid_landscape = ad_group_bid_landscape
        self.criterion_bid_landscape = criterion_bid_landscape

    @property
    def campaign_id(self):
        """Gets the campaign_id of this BidLandscape.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :return: The campaign_id of this BidLandscape.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this BidLandscape.

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this BidLandscape.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this BidLandscape.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad Gropup ID.</div>   # noqa: E501

        :return: The ad_group_id of this BidLandscape.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this BidLandscape.

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad Gropup ID.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this BidLandscape.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def start_date(self):
        """Gets the start_date of this BidLandscape.  # noqa: E501

        <div lang=\"ja\">開始日です。</div> <div lang=\"en\">Start date.</div>   # noqa: E501

        :return: The start_date of this BidLandscape.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this BidLandscape.

        <div lang=\"ja\">開始日です。</div> <div lang=\"en\">Start date.</div>   # noqa: E501

        :param start_date: The start_date of this BidLandscape.  # noqa: E501
        :type: str
        """

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this BidLandscape.  # noqa: E501

        <div lang=\"ja\">終了日です。</div> <div lang=\"en\">End date.</div>   # noqa: E501

        :return: The end_date of this BidLandscape.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this BidLandscape.

        <div lang=\"ja\">終了日です。</div> <div lang=\"en\">End date.</div>   # noqa: E501

        :param end_date: The end_date of this BidLandscape.  # noqa: E501
        :type: str
        """

        self._end_date = end_date

    @property
    def landscape_points(self):
        """Gets the landscape_points of this BidLandscape.  # noqa: E501


        :return: The landscape_points of this BidLandscape.  # noqa: E501
        :rtype: list[BidLandscapeServicePoints]
        """
        return self._landscape_points

    @landscape_points.setter
    def landscape_points(self, landscape_points):
        """Sets the landscape_points of this BidLandscape.


        :param landscape_points: The landscape_points of this BidLandscape.  # noqa: E501
        :type: list[BidLandscapeServicePoints]
        """

        self._landscape_points = landscape_points

    @property
    def bid_landscape_type(self):
        """Gets the bid_landscape_type of this BidLandscape.  # noqa: E501

        <div lang=\"ja\">BidLandscape のサブタイプを示します。</div> <div lang=\"en\">The subtype of BidLandscape.</div>   # noqa: E501

        :return: The bid_landscape_type of this BidLandscape.  # noqa: E501
        :rtype: str
        """
        return self._bid_landscape_type

    @bid_landscape_type.setter
    def bid_landscape_type(self, bid_landscape_type):
        """Sets the bid_landscape_type of this BidLandscape.

        <div lang=\"ja\">BidLandscape のサブタイプを示します。</div> <div lang=\"en\">The subtype of BidLandscape.</div>   # noqa: E501

        :param bid_landscape_type: The bid_landscape_type of this BidLandscape.  # noqa: E501
        :type: str
        """

        self._bid_landscape_type = bid_landscape_type

    @property
    def ad_group_bid_landscape(self):
        """Gets the ad_group_bid_landscape of this BidLandscape.  # noqa: E501


        :return: The ad_group_bid_landscape of this BidLandscape.  # noqa: E501
        :rtype: BidLandscapeServiceAdGroupBidLandscape
        """
        return self._ad_group_bid_landscape

    @ad_group_bid_landscape.setter
    def ad_group_bid_landscape(self, ad_group_bid_landscape):
        """Sets the ad_group_bid_landscape of this BidLandscape.


        :param ad_group_bid_landscape: The ad_group_bid_landscape of this BidLandscape.  # noqa: E501
        :type: BidLandscapeServiceAdGroupBidLandscape
        """

        self._ad_group_bid_landscape = ad_group_bid_landscape

    @property
    def criterion_bid_landscape(self):
        """Gets the criterion_bid_landscape of this BidLandscape.  # noqa: E501


        :return: The criterion_bid_landscape of this BidLandscape.  # noqa: E501
        :rtype: BidLandscapeServiceCriterionBidLandscape
        """
        return self._criterion_bid_landscape

    @criterion_bid_landscape.setter
    def criterion_bid_landscape(self, criterion_bid_landscape):
        """Sets the criterion_bid_landscape of this BidLandscape.


        :param criterion_bid_landscape: The criterion_bid_landscape of this BidLandscape.  # noqa: E501
        :type: BidLandscapeServiceCriterionBidLandscape
        """

        self._criterion_bid_landscape = criterion_bid_landscape

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BidLandscape):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BidLandscape):
            return True

        return self.to_dict() != other.to_dict()
