# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class BidLandscapeServicePoints(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'bid': 'int',
        'clicks': 'int',
        'cost': 'int',
        'impressions': 'int'
    }

    attribute_map = {
        'bid': 'bid',
        'clicks': 'clicks',
        'cost': 'cost',
        'impressions': 'impressions'
    }

    def __init__(self, bid=None, clicks=None, cost=None, impressions=None, local_vars_configuration=None):  # noqa: E501
        """BidLandscapeServicePoints - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._bid = None
        self._clicks = None
        self._cost = None
        self._impressions = None
        self.discriminator = None

        self.bid = bid
        self.clicks = clicks
        self.cost = cost
        self.impressions = impressions

    @property
    def bid(self):
        """Gets the bid of this BidLandscapeServicePoints.  # noqa: E501

        <div lang=\"ja\">この状況点のデータを予測するために使用される入札単価です。</div> <div lang=\"en\">The bid unit price used in order to estimate the data of this situation point.</div>   # noqa: E501

        :return: The bid of this BidLandscapeServicePoints.  # noqa: E501
        :rtype: int
        """
        return self._bid

    @bid.setter
    def bid(self, bid):
        """Sets the bid of this BidLandscapeServicePoints.

        <div lang=\"ja\">この状況点のデータを予測するために使用される入札単価です。</div> <div lang=\"en\">The bid unit price used in order to estimate the data of this situation point.</div>   # noqa: E501

        :param bid: The bid of this BidLandscapeServicePoints.  # noqa: E501
        :type: int
        """

        self._bid = bid

    @property
    def clicks(self):
        """Gets the clicks of this BidLandscapeServicePoints.  # noqa: E501

        <div lang=\"ja\">この入札単価での予測クリック数です。</div> <div lang=\"en\">The number of estimate clicks in this bid unit price.</div>   # noqa: E501

        :return: The clicks of this BidLandscapeServicePoints.  # noqa: E501
        :rtype: int
        """
        return self._clicks

    @clicks.setter
    def clicks(self, clicks):
        """Sets the clicks of this BidLandscapeServicePoints.

        <div lang=\"ja\">この入札単価での予測クリック数です。</div> <div lang=\"en\">The number of estimate clicks in this bid unit price.</div>   # noqa: E501

        :param clicks: The clicks of this BidLandscapeServicePoints.  # noqa: E501
        :type: int
        """

        self._clicks = clicks

    @property
    def cost(self):
        """Gets the cost of this BidLandscapeServicePoints.  # noqa: E501

        <div lang=\"ja\">この入札単価での予測コストです。</div> <div lang=\"en\">The estimate cost in this bid unit price.</div>   # noqa: E501

        :return: The cost of this BidLandscapeServicePoints.  # noqa: E501
        :rtype: int
        """
        return self._cost

    @cost.setter
    def cost(self, cost):
        """Sets the cost of this BidLandscapeServicePoints.

        <div lang=\"ja\">この入札単価での予測コストです。</div> <div lang=\"en\">The estimate cost in this bid unit price.</div>   # noqa: E501

        :param cost: The cost of this BidLandscapeServicePoints.  # noqa: E501
        :type: int
        """

        self._cost = cost

    @property
    def impressions(self):
        """Gets the impressions of this BidLandscapeServicePoints.  # noqa: E501

        <div lang=\"ja\">この入札単価での予測インプレッションです。</div> <div lang=\"en\">The estimate impressions in this bid unit price.</div>   # noqa: E501

        :return: The impressions of this BidLandscapeServicePoints.  # noqa: E501
        :rtype: int
        """
        return self._impressions

    @impressions.setter
    def impressions(self, impressions):
        """Sets the impressions of this BidLandscapeServicePoints.

        <div lang=\"ja\">この入札単価での予測インプレッションです。</div> <div lang=\"en\">The estimate impressions in this bid unit price.</div>   # noqa: E501

        :param impressions: The impressions of this BidLandscapeServicePoints.  # noqa: E501
        :type: int
        """

        self._impressions = impressions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BidLandscapeServicePoints):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BidLandscapeServicePoints):
            return True

        return self.to_dict() != other.to_dict()
