# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class BidLandscapeServiceSelector(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'campaign_id': 'int',
        'ad_group_id': 'int',
        'criterion_ids': 'list[int]',
        'sim_type': 'BidLandscapeServiceSimType',
        'start_index': 'int',
        'number_results': 'int'
    }

    attribute_map = {
        'account_id': 'accountId',
        'campaign_id': 'campaignId',
        'ad_group_id': 'adGroupId',
        'criterion_ids': 'criterionIds',
        'sim_type': 'simType',
        'start_index': 'startIndex',
        'number_results': 'numberResults'
    }

    def __init__(self, account_id=None, campaign_id=None, ad_group_id=None, criterion_ids=None, sim_type=None, start_index=1, number_results=100, local_vars_configuration=None):  # noqa: E501
        """BidLandscapeServiceSelector - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._campaign_id = None
        self._ad_group_id = None
        self._criterion_ids = None
        self._sim_type = None
        self._start_index = None
        self._number_results = None
        self.discriminator = None

        self.account_id = account_id
        self.campaign_id = campaign_id
        self.ad_group_id = ad_group_id
        self.criterion_ids = criterion_ids
        self.sim_type = sim_type
        self.start_index = start_index
        self.number_results = number_results

    @property
    def account_id(self):
        """Gets the account_id of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID</div>   # noqa: E501

        :return: The account_id of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this BidLandscapeServiceSelector.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID</div>   # noqa: E501

        :param account_id: The account_id of this BidLandscapeServiceSelector.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def campaign_id(self):
        """Gets the campaign_id of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID</div>   # noqa: E501

        :return: The campaign_id of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this BidLandscapeServiceSelector.

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID</div>   # noqa: E501

        :param campaign_id: The campaign_id of this BidLandscapeServiceSelector.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad Gropup ID.</div>   # noqa: E501

        :return: The ad_group_id of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this BidLandscapeServiceSelector.

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">Ad Gropup ID.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this BidLandscapeServiceSelector.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def criterion_ids(self):
        """Gets the criterion_ids of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">クライテリアIDです。最大100個まで指定できます。</div> <div lang=\"en\">ID of this criterion. The maximum value is 100.</div>   # noqa: E501

        :return: The criterion_ids of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: list[int]
        """
        return self._criterion_ids

    @criterion_ids.setter
    def criterion_ids(self, criterion_ids):
        """Sets the criterion_ids of this BidLandscapeServiceSelector.

        <div lang=\"ja\">クライテリアIDです。最大100個まで指定できます。</div> <div lang=\"en\">ID of this criterion. The maximum value is 100.</div>   # noqa: E501

        :param criterion_ids: The criterion_ids of this BidLandscapeServiceSelector.  # noqa: E501
        :type: list[int]
        """

        self._criterion_ids = criterion_ids

    @property
    def sim_type(self):
        """Gets the sim_type of this BidLandscapeServiceSelector.  # noqa: E501


        :return: The sim_type of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: BidLandscapeServiceSimType
        """
        return self._sim_type

    @sim_type.setter
    def sim_type(self, sim_type):
        """Sets the sim_type of this BidLandscapeServiceSelector.


        :param sim_type: The sim_type of this BidLandscapeServiceSelector.  # noqa: E501
        :type: BidLandscapeServiceSimType
        """

        self._sim_type = sim_type

    @property
    def start_index(self):
        """Gets the start_index of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :return: The start_index of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._start_index

    @start_index.setter
    def start_index(self, start_index):
        """Sets the start_index of this BidLandscapeServiceSelector.

        <div lang=\"ja\">ページの先頭のインデックスです。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Index of the first result to return in this page. This field must be greater than or equal to 1.</div>   # noqa: E501

        :param start_index: The start_index of this BidLandscapeServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                start_index is not None and start_index < 1):  # noqa: E501
            raise ValueError("Invalid value for `start_index`, must be a value greater than or equal to `1`")  # noqa: E501

        self._start_index = start_index

    @property
    def number_results(self):
        """Gets the number_results of this BidLandscapeServiceSelector.  # noqa: E501

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :return: The number_results of this BidLandscapeServiceSelector.  # noqa: E501
        :rtype: int
        """
        return self._number_results

    @number_results.setter
    def number_results(self, number_results):
        """Sets the number_results of this BidLandscapeServiceSelector.

        <div lang=\"ja\">ページの最大件数です。このフィールドは、1以上を指定する必要があります。</div> <div lang=\"en\">Maximum number of results to return in this page. This field must be greater than or equal to 1. Also see Entity Limits per operation.</div>   # noqa: E501

        :param number_results: The number_results of this BidLandscapeServiceSelector.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results > 100):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                number_results is not None and number_results < 1):  # noqa: E501
            raise ValueError("Invalid value for `number_results`, must be a value greater than or equal to `1`")  # noqa: E501

        self._number_results = number_results

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BidLandscapeServiceSelector):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BidLandscapeServiceSelector):
            return True

        return self.to_dict() != other.to_dict()
