# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class CampaignExportServiceFieldAttribute(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_field_name_en': 'str',
        'display_field_name_ja': 'str',
        'field_name': 'str'
    }

    attribute_map = {
        'display_field_name_en': 'displayFieldNameEN',
        'display_field_name_ja': 'displayFieldNameJA',
        'field_name': 'fieldName'
    }

    def __init__(self, display_field_name_en=None, display_field_name_ja=None, field_name=None, local_vars_configuration=None):  # noqa: E501
        """CampaignExportServiceFieldAttribute - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_field_name_en = None
        self._display_field_name_ja = None
        self._field_name = None
        self.discriminator = None

        self.display_field_name_en = display_field_name_en
        self.display_field_name_ja = display_field_name_ja
        self.field_name = field_name

    @property
    def display_field_name_en(self):
        """Gets the display_field_name_en of this CampaignExportServiceFieldAttribute.  # noqa: E501

        <div lang=\"ja\">フィールドの英語表示名です。</div> <div lang=\"en\">Display name (EN)</div>   # noqa: E501

        :return: The display_field_name_en of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :rtype: str
        """
        return self._display_field_name_en

    @display_field_name_en.setter
    def display_field_name_en(self, display_field_name_en):
        """Sets the display_field_name_en of this CampaignExportServiceFieldAttribute.

        <div lang=\"ja\">フィールドの英語表示名です。</div> <div lang=\"en\">Display name (EN)</div>   # noqa: E501

        :param display_field_name_en: The display_field_name_en of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :type: str
        """

        self._display_field_name_en = display_field_name_en

    @property
    def display_field_name_ja(self):
        """Gets the display_field_name_ja of this CampaignExportServiceFieldAttribute.  # noqa: E501

        <div lang=\"ja\">フィールドの日本語表示名です。</div> <div lang=\"en\">Display name (JA)</div>   # noqa: E501

        :return: The display_field_name_ja of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :rtype: str
        """
        return self._display_field_name_ja

    @display_field_name_ja.setter
    def display_field_name_ja(self, display_field_name_ja):
        """Sets the display_field_name_ja of this CampaignExportServiceFieldAttribute.

        <div lang=\"ja\">フィールドの日本語表示名です。</div> <div lang=\"en\">Display name (JA)</div>   # noqa: E501

        :param display_field_name_ja: The display_field_name_ja of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :type: str
        """

        self._display_field_name_ja = display_field_name_ja

    @property
    def field_name(self):
        """Gets the field_name of this CampaignExportServiceFieldAttribute.  # noqa: E501

        <div lang=\"ja\">フィールド名です。</div> <div lang=\"en\">Field name</div>   # noqa: E501

        :return: The field_name of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :rtype: str
        """
        return self._field_name

    @field_name.setter
    def field_name(self, field_name):
        """Sets the field_name of this CampaignExportServiceFieldAttribute.

        <div lang=\"ja\">フィールド名です。</div> <div lang=\"en\">Field name</div>   # noqa: E501

        :param field_name: The field_name of this CampaignExportServiceFieldAttribute.  # noqa: E501
        :type: str
        """

        self._field_name = field_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignExportServiceFieldAttribute):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignExportServiceFieldAttribute):
            return True

        return self.to_dict() != other.to_dict()
