# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class CampaignRetargetingList(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'bid_multiplier': 'float',
        'campaign_id': 'int',
        'campaign_name': 'str',
        'criterion_target_list': 'CampaignRetargetingListServiceCriterionTargetList',
        'excluded_type': 'CampaignRetargetingListServiceExcludedType'
    }

    attribute_map = {
        'account_id': 'accountId',
        'bid_multiplier': 'bidMultiplier',
        'campaign_id': 'campaignId',
        'campaign_name': 'campaignName',
        'criterion_target_list': 'criterionTargetList',
        'excluded_type': 'excludedType'
    }

    def __init__(self, account_id=None, bid_multiplier=None, campaign_id=None, campaign_name=None, criterion_target_list=None, excluded_type=None, local_vars_configuration=None):  # noqa: E501
        """CampaignRetargetingList - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._bid_multiplier = None
        self._campaign_id = None
        self._campaign_name = None
        self._criterion_target_list = None
        self._excluded_type = None
        self.discriminator = None

        self.account_id = account_id
        self.bid_multiplier = bid_multiplier
        self.campaign_id = campaign_id
        self.campaign_name = campaign_name
        self.criterion_target_list = criterion_target_list
        self.excluded_type = excluded_type

    @property
    def account_id(self):
        """Gets the account_id of this CampaignRetargetingList.  # noqa: E501

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :return: The account_id of this CampaignRetargetingList.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this CampaignRetargetingList.

        <div lang=\"ja\">アカウントIDです。</div> <div lang=\"en\">Account ID.</div>   # noqa: E501

        :param account_id: The account_id of this CampaignRetargetingList.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def bid_multiplier(self):
        """Gets the bid_multiplier of this CampaignRetargetingList.  # noqa: E501

        <div lang=\"ja\">入札価格調整率です。<br>このフィールドは、いずれの場合でも省略可能となります。</div> <div lang=\"en\">Bid adjustment rate.<br>This field is optional in any cases.</div>   # noqa: E501

        :return: The bid_multiplier of this CampaignRetargetingList.  # noqa: E501
        :rtype: float
        """
        return self._bid_multiplier

    @bid_multiplier.setter
    def bid_multiplier(self, bid_multiplier):
        """Sets the bid_multiplier of this CampaignRetargetingList.

        <div lang=\"ja\">入札価格調整率です。<br>このフィールドは、いずれの場合でも省略可能となります。</div> <div lang=\"en\">Bid adjustment rate.<br>This field is optional in any cases.</div>   # noqa: E501

        :param bid_multiplier: The bid_multiplier of this CampaignRetargetingList.  # noqa: E501
        :type: float
        """

        self._bid_multiplier = bid_multiplier

    @property
    def campaign_id(self):
        """Gets the campaign_id of this CampaignRetargetingList.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br>This field is required in any cases.</div>   # noqa: E501

        :return: The campaign_id of this CampaignRetargetingList.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this CampaignRetargetingList.

        <div lang=\"ja\">キャンペーンIDです。<br>このフィールドは、いずれの場合でも必須です。</div> <div lang=\"en\">Campaign ID.<br>This field is required in any cases.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this CampaignRetargetingList.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def campaign_name(self):
        """Gets the campaign_name of this CampaignRetargetingList.  # noqa: E501

        <div lang=\"ja\">キャンペーン名称です。</div> <div lang=\"en\">Name of campaign.</div>   # noqa: E501

        :return: The campaign_name of this CampaignRetargetingList.  # noqa: E501
        :rtype: str
        """
        return self._campaign_name

    @campaign_name.setter
    def campaign_name(self, campaign_name):
        """Sets the campaign_name of this CampaignRetargetingList.

        <div lang=\"ja\">キャンペーン名称です。</div> <div lang=\"en\">Name of campaign.</div>   # noqa: E501

        :param campaign_name: The campaign_name of this CampaignRetargetingList.  # noqa: E501
        :type: str
        """

        self._campaign_name = campaign_name

    @property
    def criterion_target_list(self):
        """Gets the criterion_target_list of this CampaignRetargetingList.  # noqa: E501


        :return: The criterion_target_list of this CampaignRetargetingList.  # noqa: E501
        :rtype: CampaignRetargetingListServiceCriterionTargetList
        """
        return self._criterion_target_list

    @criterion_target_list.setter
    def criterion_target_list(self, criterion_target_list):
        """Sets the criterion_target_list of this CampaignRetargetingList.


        :param criterion_target_list: The criterion_target_list of this CampaignRetargetingList.  # noqa: E501
        :type: CampaignRetargetingListServiceCriterionTargetList
        """

        self._criterion_target_list = criterion_target_list

    @property
    def excluded_type(self):
        """Gets the excluded_type of this CampaignRetargetingList.  # noqa: E501


        :return: The excluded_type of this CampaignRetargetingList.  # noqa: E501
        :rtype: CampaignRetargetingListServiceExcludedType
        """
        return self._excluded_type

    @excluded_type.setter
    def excluded_type(self, excluded_type):
        """Sets the excluded_type of this CampaignRetargetingList.


        :param excluded_type: The excluded_type of this CampaignRetargetingList.  # noqa: E501
        :type: CampaignRetargetingListServiceExcludedType
        """

        self._excluded_type = excluded_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignRetargetingList):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignRetargetingList):
            return True

        return self.to_dict() != other.to_dict()
