# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class CampaignServiceSettings(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dynamic_ads_for_search_setting': 'CampaignServiceDynamicAdsForSearchSetting',
        'geo_target_type_setting': 'CampaignServiceGeoTargetTypeSetting',
        'setting_type': 'CampaignServiceSettingType',
        'targeting_setting': 'CampaignServiceTargetingSetting'
    }

    attribute_map = {
        'dynamic_ads_for_search_setting': 'dynamicAdsForSearchSetting',
        'geo_target_type_setting': 'geoTargetTypeSetting',
        'setting_type': 'settingType',
        'targeting_setting': 'targetingSetting'
    }

    def __init__(self, dynamic_ads_for_search_setting=None, geo_target_type_setting=None, setting_type=None, targeting_setting=None, local_vars_configuration=None):  # noqa: E501
        """CampaignServiceSettings - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._dynamic_ads_for_search_setting = None
        self._geo_target_type_setting = None
        self._setting_type = None
        self._targeting_setting = None
        self.discriminator = None

        self.dynamic_ads_for_search_setting = dynamic_ads_for_search_setting
        self.geo_target_type_setting = geo_target_type_setting
        self.setting_type = setting_type
        self.targeting_setting = targeting_setting

    @property
    def dynamic_ads_for_search_setting(self):
        """Gets the dynamic_ads_for_search_setting of this CampaignServiceSettings.  # noqa: E501


        :return: The dynamic_ads_for_search_setting of this CampaignServiceSettings.  # noqa: E501
        :rtype: CampaignServiceDynamicAdsForSearchSetting
        """
        return self._dynamic_ads_for_search_setting

    @dynamic_ads_for_search_setting.setter
    def dynamic_ads_for_search_setting(self, dynamic_ads_for_search_setting):
        """Sets the dynamic_ads_for_search_setting of this CampaignServiceSettings.


        :param dynamic_ads_for_search_setting: The dynamic_ads_for_search_setting of this CampaignServiceSettings.  # noqa: E501
        :type: CampaignServiceDynamicAdsForSearchSetting
        """

        self._dynamic_ads_for_search_setting = dynamic_ads_for_search_setting

    @property
    def geo_target_type_setting(self):
        """Gets the geo_target_type_setting of this CampaignServiceSettings.  # noqa: E501


        :return: The geo_target_type_setting of this CampaignServiceSettings.  # noqa: E501
        :rtype: CampaignServiceGeoTargetTypeSetting
        """
        return self._geo_target_type_setting

    @geo_target_type_setting.setter
    def geo_target_type_setting(self, geo_target_type_setting):
        """Sets the geo_target_type_setting of this CampaignServiceSettings.


        :param geo_target_type_setting: The geo_target_type_setting of this CampaignServiceSettings.  # noqa: E501
        :type: CampaignServiceGeoTargetTypeSetting
        """

        self._geo_target_type_setting = geo_target_type_setting

    @property
    def setting_type(self):
        """Gets the setting_type of this CampaignServiceSettings.  # noqa: E501


        :return: The setting_type of this CampaignServiceSettings.  # noqa: E501
        :rtype: CampaignServiceSettingType
        """
        return self._setting_type

    @setting_type.setter
    def setting_type(self, setting_type):
        """Sets the setting_type of this CampaignServiceSettings.


        :param setting_type: The setting_type of this CampaignServiceSettings.  # noqa: E501
        :type: CampaignServiceSettingType
        """

        self._setting_type = setting_type

    @property
    def targeting_setting(self):
        """Gets the targeting_setting of this CampaignServiceSettings.  # noqa: E501


        :return: The targeting_setting of this CampaignServiceSettings.  # noqa: E501
        :rtype: CampaignServiceTargetingSetting
        """
        return self._targeting_setting

    @targeting_setting.setter
    def targeting_setting(self, targeting_setting):
        """Sets the targeting_setting of this CampaignServiceSettings.


        :param targeting_setting: The targeting_setting of this CampaignServiceSettings.  # noqa: E501
        :type: CampaignServiceTargetingSetting
        """

        self._targeting_setting = targeting_setting

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignServiceSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignServiceSettings):
            return True

        return self.to_dict() != other.to_dict()
