# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class FeedItemServiceFeedAttributeValue(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'disapproval_reason_codes': 'list[str]',
        'feed_attribute_value': 'str',
        'review_feed_attribute_value': 'str'
    }

    attribute_map = {
        'disapproval_reason_codes': 'disapprovalReasonCodes',
        'feed_attribute_value': 'feedAttributeValue',
        'review_feed_attribute_value': 'reviewFeedAttributeValue'
    }

    def __init__(self, disapproval_reason_codes=None, feed_attribute_value=None, review_feed_attribute_value=None, local_vars_configuration=None):  # noqa: E501
        """FeedItemServiceFeedAttributeValue - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._disapproval_reason_codes = None
        self._feed_attribute_value = None
        self._review_feed_attribute_value = None
        self.discriminator = None

        self.disapproval_reason_codes = disapproval_reason_codes
        self.feed_attribute_value = feed_attribute_value
        self.review_feed_attribute_value = review_feed_attribute_value

    @property
    def disapproval_reason_codes(self):
        """Gets the disapproval_reason_codes of this FeedItemServiceFeedAttributeValue.  # noqa: E501

        <div lang=\"ja\">審査の否認理由コードです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Reject reason code of editorial review.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The disapproval_reason_codes of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :rtype: list[str]
        """
        return self._disapproval_reason_codes

    @disapproval_reason_codes.setter
    def disapproval_reason_codes(self, disapproval_reason_codes):
        """Sets the disapproval_reason_codes of this FeedItemServiceFeedAttributeValue.

        <div lang=\"ja\">審査の否認理由コードです。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">Reject reason code of editorial review.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param disapproval_reason_codes: The disapproval_reason_codes of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :type: list[str]
        """

        self._disapproval_reason_codes = disapproval_reason_codes

    @property
    def feed_attribute_value(self):
        """Gets the feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501

        <div lang=\"ja\">フィードアイテムの属性値です。<br> このフィールドは、ADDおよびSET時に必須となり、REMOVE時は無視されます。</div> <div lang=\"en\">FeedItem attribute value.<br> This field is required in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :return: The feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :rtype: str
        """
        return self._feed_attribute_value

    @feed_attribute_value.setter
    def feed_attribute_value(self, feed_attribute_value):
        """Sets the feed_attribute_value of this FeedItemServiceFeedAttributeValue.

        <div lang=\"ja\">フィードアイテムの属性値です。<br> このフィールドは、ADDおよびSET時に必須となり、REMOVE時は無視されます。</div> <div lang=\"en\">FeedItem attribute value.<br> This field is required in ADD and SET operation, and will be ignored in REMOVE operation.</div>   # noqa: E501

        :param feed_attribute_value: The feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :type: str
        """

        self._feed_attribute_value = feed_attribute_value

    @property
    def review_feed_attribute_value(self):
        """Gets the review_feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501

        <div lang=\"ja\">レビュー中のフィードアイテムの属性値です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">FeedItem attribute value in review.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :return: The review_feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :rtype: str
        """
        return self._review_feed_attribute_value

    @review_feed_attribute_value.setter
    def review_feed_attribute_value(self, review_feed_attribute_value):
        """Sets the review_feed_attribute_value of this FeedItemServiceFeedAttributeValue.

        <div lang=\"ja\">レビュー中のフィードアイテムの属性値です。<br> このフィールドは、レスポンスの際に返却されますが、リクエストの際には無視されます。</div> <div lang=\"en\">FeedItem attribute value in review.<br> Although this field will be returned in the response, it will be ignored on input.</div>   # noqa: E501

        :param review_feed_attribute_value: The review_feed_attribute_value of this FeedItemServiceFeedAttributeValue.  # noqa: E501
        :type: str
        """

        self._review_feed_attribute_value = review_feed_attribute_value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeedItemServiceFeedAttributeValue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeedItemServiceFeedAttributeValue):
            return True

        return self.to_dict() != other.to_dict()
