# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class KeywordEstimatorServiceAdGroupEstimateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ad_group_id': 'int',
        'keyword_estimate_requests': 'list[KeywordEstimatorServiceKeywordEstimateRequest]',
        'max_cpc': 'int'
    }

    attribute_map = {
        'ad_group_id': 'adGroupId',
        'keyword_estimate_requests': 'keywordEstimateRequests',
        'max_cpc': 'maxCpc'
    }

    def __init__(self, ad_group_id=None, keyword_estimate_requests=None, max_cpc=None, local_vars_configuration=None):  # noqa: E501
        """KeywordEstimatorServiceAdGroupEstimateRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ad_group_id = None
        self._keyword_estimate_requests = None
        self._max_cpc = None
        self.discriminator = None

        self.ad_group_id = ad_group_id
        self.keyword_estimate_requests = keyword_estimate_requests
        self.max_cpc = max_cpc

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">AdGroupID</div>   # noqa: E501

        :return: The ad_group_id of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this KeywordEstimatorServiceAdGroupEstimateRequest.

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">AdGroupID</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def keyword_estimate_requests(self):
        """Gets the keyword_estimate_requests of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501

        <div lang=\"ja\">見積もりを行うキーワードのコンテナです。</div> <div lang=\"en\">A container for the keywords to estimate</div>   # noqa: E501

        :return: The keyword_estimate_requests of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :rtype: list[KeywordEstimatorServiceKeywordEstimateRequest]
        """
        return self._keyword_estimate_requests

    @keyword_estimate_requests.setter
    def keyword_estimate_requests(self, keyword_estimate_requests):
        """Sets the keyword_estimate_requests of this KeywordEstimatorServiceAdGroupEstimateRequest.

        <div lang=\"ja\">見積もりを行うキーワードのコンテナです。</div> <div lang=\"en\">A container for the keywords to estimate</div>   # noqa: E501

        :param keyword_estimate_requests: The keyword_estimate_requests of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :type: list[KeywordEstimatorServiceKeywordEstimateRequest]
        """

        self._keyword_estimate_requests = keyword_estimate_requests

    @property
    def max_cpc(self):
        """Gets the max_cpc of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501

        <div lang=\"ja\">広告グループの見積もりに使用する上限クリック単価です。</div> <div lang=\"en\">Max CPC for Ad Group estimate</div>   # noqa: E501

        :return: The max_cpc of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :rtype: int
        """
        return self._max_cpc

    @max_cpc.setter
    def max_cpc(self, max_cpc):
        """Sets the max_cpc of this KeywordEstimatorServiceAdGroupEstimateRequest.

        <div lang=\"ja\">広告グループの見積もりに使用する上限クリック単価です。</div> <div lang=\"en\">Max CPC for Ad Group estimate</div>   # noqa: E501

        :param max_cpc: The max_cpc of this KeywordEstimatorServiceAdGroupEstimateRequest.  # noqa: E501
        :type: int
        """

        self._max_cpc = max_cpc

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeywordEstimatorServiceAdGroupEstimateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeywordEstimatorServiceAdGroupEstimateRequest):
            return True

        return self.to_dict() != other.to_dict()
