# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class KeywordEstimatorServiceEstimateResult(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'clicks': 'float',
        'cost': 'float',
        'cpc': 'float',
        'ctr': 'float',
        'impressions': 'float',
        'rank': 'float'
    }

    attribute_map = {
        'clicks': 'clicks',
        'cost': 'cost',
        'cpc': 'cpc',
        'ctr': 'ctr',
        'impressions': 'impressions',
        'rank': 'rank'
    }

    def __init__(self, clicks=None, cost=None, cpc=None, ctr=None, impressions=None, rank=None, local_vars_configuration=None):  # noqa: E501
        """KeywordEstimatorServiceEstimateResult - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._clicks = None
        self._cost = None
        self._cpc = None
        self._ctr = None
        self._impressions = None
        self._rank = None
        self.discriminator = None

        self.clicks = clicks
        self.cost = cost
        self.cpc = cpc
        self.ctr = ctr
        self.impressions = impressions
        self.rank = rank

    @property
    def clicks(self):
        """Gets the clicks of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">1日あたりのクリック数です。</div> <div lang=\"en\">Number of clicks per day</div>   # noqa: E501

        :return: The clicks of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._clicks

    @clicks.setter
    def clicks(self, clicks):
        """Sets the clicks of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">1日あたりのクリック数です。</div> <div lang=\"en\">Number of clicks per day</div>   # noqa: E501

        :param clicks: The clicks of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._clicks = clicks

    @property
    def cost(self):
        """Gets the cost of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">1日あたりの推定合計費用です。</div> <div lang=\"en\">Total amount of CPC cost per day</div>   # noqa: E501

        :return: The cost of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._cost

    @cost.setter
    def cost(self, cost):
        """Sets the cost of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">1日あたりの推定合計費用です。</div> <div lang=\"en\">Total amount of CPC cost per day</div>   # noqa: E501

        :param cost: The cost of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._cost = cost

    @property
    def cpc(self):
        """Gets the cpc of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">推定平均クリック単価です。</div> <div lang=\"en\">Assumed average CPC</div>   # noqa: E501

        :return: The cpc of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._cpc

    @cpc.setter
    def cpc(self, cpc):
        """Sets the cpc of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">推定平均クリック単価です。</div> <div lang=\"en\">Assumed average CPC</div>   # noqa: E501

        :param cpc: The cpc of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._cpc = cpc

    @property
    def ctr(self):
        """Gets the ctr of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">推定CTRです。</div> <div lang=\"en\">Estimation of CTR.</div>   # noqa: E501

        :return: The ctr of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._ctr

    @ctr.setter
    def ctr(self, ctr):
        """Sets the ctr of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">推定CTRです。</div> <div lang=\"en\">Estimation of CTR.</div>   # noqa: E501

        :param ctr: The ctr of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._ctr = ctr

    @property
    def impressions(self):
        """Gets the impressions of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">1日当たりの推定インプレッション数です。</div> <div lang=\"en\">Estimation of impression per day.</div>   # noqa: E501

        :return: The impressions of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._impressions

    @impressions.setter
    def impressions(self, impressions):
        """Sets the impressions of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">1日当たりの推定インプレッション数です。</div> <div lang=\"en\">Estimation of impression per day.</div>   # noqa: E501

        :param impressions: The impressions of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._impressions = impressions

    @property
    def rank(self):
        """Gets the rank of this KeywordEstimatorServiceEstimateResult.  # noqa: E501

        <div lang=\"ja\">推定平均掲載順位です。</div> <div lang=\"en\">Assumed average display rank</div>   # noqa: E501

        :return: The rank of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :rtype: float
        """
        return self._rank

    @rank.setter
    def rank(self, rank):
        """Sets the rank of this KeywordEstimatorServiceEstimateResult.

        <div lang=\"ja\">推定平均掲載順位です。</div> <div lang=\"en\">Assumed average display rank</div>   # noqa: E501

        :param rank: The rank of this KeywordEstimatorServiceEstimateResult.  # noqa: E501
        :type: float
        """

        self._rank = rank

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeywordEstimatorServiceEstimateResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeywordEstimatorServiceEstimateResult):
            return True

        return self.to_dict() != other.to_dict()
