# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class KeywordEstimatorServiceKeywordEstimateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'estimate_keyword': 'KeywordEstimatorServiceEstimateKeyword',
        'is_negative_bool': 'KeywordEstimatorServiceIsNegativeBool',
        'max_cpc': 'int'
    }

    attribute_map = {
        'estimate_keyword': 'estimateKeyword',
        'is_negative_bool': 'isNegativeBool',
        'max_cpc': 'maxCpc'
    }

    def __init__(self, estimate_keyword=None, is_negative_bool=None, max_cpc=None, local_vars_configuration=None):  # noqa: E501
        """KeywordEstimatorServiceKeywordEstimateRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._estimate_keyword = None
        self._is_negative_bool = None
        self._max_cpc = None
        self.discriminator = None

        self.estimate_keyword = estimate_keyword
        self.is_negative_bool = is_negative_bool
        self.max_cpc = max_cpc

    @property
    def estimate_keyword(self):
        """Gets the estimate_keyword of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501


        :return: The estimate_keyword of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :rtype: KeywordEstimatorServiceEstimateKeyword
        """
        return self._estimate_keyword

    @estimate_keyword.setter
    def estimate_keyword(self, estimate_keyword):
        """Sets the estimate_keyword of this KeywordEstimatorServiceKeywordEstimateRequest.


        :param estimate_keyword: The estimate_keyword of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :type: KeywordEstimatorServiceEstimateKeyword
        """

        self._estimate_keyword = estimate_keyword

    @property
    def is_negative_bool(self):
        """Gets the is_negative_bool of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501


        :return: The is_negative_bool of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :rtype: KeywordEstimatorServiceIsNegativeBool
        """
        return self._is_negative_bool

    @is_negative_bool.setter
    def is_negative_bool(self, is_negative_bool):
        """Sets the is_negative_bool of this KeywordEstimatorServiceKeywordEstimateRequest.


        :param is_negative_bool: The is_negative_bool of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :type: KeywordEstimatorServiceIsNegativeBool
        """

        self._is_negative_bool = is_negative_bool

    @property
    def max_cpc(self):
        """Gets the max_cpc of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501

        <div lang=\"ja\">キーワードの見積もりに使用する上限クリック単価です。</div> <div lang=\"en\">maxCpc for the keyword</div>   # noqa: E501

        :return: The max_cpc of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :rtype: int
        """
        return self._max_cpc

    @max_cpc.setter
    def max_cpc(self, max_cpc):
        """Sets the max_cpc of this KeywordEstimatorServiceKeywordEstimateRequest.

        <div lang=\"ja\">キーワードの見積もりに使用する上限クリック単価です。</div> <div lang=\"en\">maxCpc for the keyword</div>   # noqa: E501

        :param max_cpc: The max_cpc of this KeywordEstimatorServiceKeywordEstimateRequest.  # noqa: E501
        :type: int
        """

        self._max_cpc = max_cpc

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeywordEstimatorServiceKeywordEstimateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeywordEstimatorServiceKeywordEstimateRequest):
            return True

        return self.to_dict() != other.to_dict()
