# coding: utf-8

"""
    Yahoo!広告 検索広告 API リファレンス / Yahoo! Ads Search Ads API Reference

    <div lang=\"ja\">Yahoo!広告 検索広告 APIのWebサービスについて説明します。<br> 「Try it out」のご利用には、事前にアプリケーションの登録が必要です。また、アプリケーションのリダイレクトURIの1つに<br> https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.htmlを登録してください。 </div> <div lang=\"en\">Search Ads API Web Services supported in Yahoo! Ads API.<br> When you use \"Try it out\", you need to register your application in advance.<br> As one of redirect URI for application, you need to set \"https://yahoojp-marketing.github.io/ads-search-api-documents/oauth2-redirect.html\". </div>   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from yahoo_ads_search.configuration import Configuration


class KeywordEstimatorServiceResult(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ad_group_id': 'int',
        'campaign_id': 'int',
        'keyword': 'str',
        'max': 'KeywordEstimatorServiceEstimateResult',
        'min': 'KeywordEstimatorServiceEstimateResult'
    }

    attribute_map = {
        'ad_group_id': 'adGroupId',
        'campaign_id': 'campaignId',
        'keyword': 'keyword',
        'max': 'max',
        'min': 'min'
    }

    def __init__(self, ad_group_id=None, campaign_id=None, keyword=None, max=None, min=None, local_vars_configuration=None):  # noqa: E501
        """KeywordEstimatorServiceResult - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ad_group_id = None
        self._campaign_id = None
        self._keyword = None
        self._max = None
        self._min = None
        self.discriminator = None

        self.ad_group_id = ad_group_id
        self.campaign_id = campaign_id
        self.keyword = keyword
        self.max = max
        self.min = min

    @property
    def ad_group_id(self):
        """Gets the ad_group_id of this KeywordEstimatorServiceResult.  # noqa: E501

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">AdGroup ID.</div>   # noqa: E501

        :return: The ad_group_id of this KeywordEstimatorServiceResult.  # noqa: E501
        :rtype: int
        """
        return self._ad_group_id

    @ad_group_id.setter
    def ad_group_id(self, ad_group_id):
        """Sets the ad_group_id of this KeywordEstimatorServiceResult.

        <div lang=\"ja\">広告グループIDです。</div> <div lang=\"en\">AdGroup ID.</div>   # noqa: E501

        :param ad_group_id: The ad_group_id of this KeywordEstimatorServiceResult.  # noqa: E501
        :type: int
        """

        self._ad_group_id = ad_group_id

    @property
    def campaign_id(self):
        """Gets the campaign_id of this KeywordEstimatorServiceResult.  # noqa: E501

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :return: The campaign_id of this KeywordEstimatorServiceResult.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this KeywordEstimatorServiceResult.

        <div lang=\"ja\">キャンペーンIDです。</div> <div lang=\"en\">Campaign ID.</div>   # noqa: E501

        :param campaign_id: The campaign_id of this KeywordEstimatorServiceResult.  # noqa: E501
        :type: int
        """

        self._campaign_id = campaign_id

    @property
    def keyword(self):
        """Gets the keyword of this KeywordEstimatorServiceResult.  # noqa: E501

        <div lang=\"ja\">キーワードです。</div> <div lang=\"en\">Keywords.</div>   # noqa: E501

        :return: The keyword of this KeywordEstimatorServiceResult.  # noqa: E501
        :rtype: str
        """
        return self._keyword

    @keyword.setter
    def keyword(self, keyword):
        """Sets the keyword of this KeywordEstimatorServiceResult.

        <div lang=\"ja\">キーワードです。</div> <div lang=\"en\">Keywords.</div>   # noqa: E501

        :param keyword: The keyword of this KeywordEstimatorServiceResult.  # noqa: E501
        :type: str
        """

        self._keyword = keyword

    @property
    def max(self):
        """Gets the max of this KeywordEstimatorServiceResult.  # noqa: E501


        :return: The max of this KeywordEstimatorServiceResult.  # noqa: E501
        :rtype: KeywordEstimatorServiceEstimateResult
        """
        return self._max

    @max.setter
    def max(self, max):
        """Sets the max of this KeywordEstimatorServiceResult.


        :param max: The max of this KeywordEstimatorServiceResult.  # noqa: E501
        :type: KeywordEstimatorServiceEstimateResult
        """

        self._max = max

    @property
    def min(self):
        """Gets the min of this KeywordEstimatorServiceResult.  # noqa: E501


        :return: The min of this KeywordEstimatorServiceResult.  # noqa: E501
        :rtype: KeywordEstimatorServiceEstimateResult
        """
        return self._min

    @min.setter
    def min(self, min):
        """Sets the min of this KeywordEstimatorServiceResult.


        :param min: The min of this KeywordEstimatorServiceResult.  # noqa: E501
        :type: KeywordEstimatorServiceEstimateResult
        """

        self._min = min

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeywordEstimatorServiceResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeywordEstimatorServiceResult):
            return True

        return self.to_dict() != other.to_dict()
